Last Comment Bug 804634 - Marketplace URL is changing
: Marketplace URL is changing
Status: VERIFIED FIXED
: perf
Product: Firefox OS
Classification: Client Software
Component: Gaia (show other bugs)
: unspecified
: All All
: P1 normal (vote)
: B2G C2 (20nov-10dec)
Assigned To: Christopher Van Wiemeersch [:cvan]
:
Mentors:
Depends on: 799563 802561
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-23 09:44 PDT by Wil Clouser [:clouserw]
Modified: 2013-01-04 15:44 PST (History)
40 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
+


Attachments

Description Wil Clouser [:clouserw] 2012-10-23 09:44:27 PDT
The URL for the marketplace is being changed:

     marketplace.mozilla.org -> marketplace.firefox.com

It'll turn into a redirect so nothing should break but you don't want to go through a 301 every time.  Note the blocking bug - it's tracking the change in the marketplace.
Comment 1 Jason Smith [:jsmith] 2012-10-23 10:26:20 PDT
Sounds like something we should take care of before we ship - marketing has been extremely critical about the URL being marketplace.firefox.com instead of marketplace.mozilla.org. Although one could make the argument that we could leave behind what we have and do a 301 to marketplace.firefox.com. But it might be worth getting this done sooner rather than later.
Comment 2 Mike Connor [:mconnor] 2012-10-25 08:25:44 PDT
Per triage: plussing, as this will impact perceived performance for every fresh session with marketplace.
Comment 3 Chris More [:cmore] 2012-10-25 13:05:31 PDT
(In reply to Wil Clouser [:clouserw] from comment #0)
> The URL for the marketplace is being changed:
> 
>      marketplace.mozilla.org -> marketplace.firefox.com
> 
> It'll turn into a redirect so nothing should break but you don't want to go
> through a 301 every time.  Note the blocking bug - it's tracking the change
> in the marketplace.

How is this in-line with the One Mozilla domain name strategy?

https://wiki.mozilla.org/Websites/Taskforce/Proposals/Domain_Name_Strategy
Comment 4 Chris More [:cmore] 2012-10-25 13:06:22 PDT
(In reply to Jason Smith [:jsmith] from comment #1)
> Sounds like something we should take care of before we ship - marketing has
> been extremely critical about the URL being marketplace.firefox.com instead
> of marketplace.mozilla.org. Although one could make the argument that we
> could leave behind what we have and do a 301 to marketplace.firefox.com. But
> it might be worth getting this done sooner rather than later.

Hey Jason.

When you say "marketing", who specifically are you referring to? This is the first I've heard about this.
Comment 5 John Slater 2012-10-25 13:10:00 PDT
+1 for what cmore said. This warrants further discussion...decisions around URLs like this shouldn't be made unilaterally.
Comment 6 Matt Basta [:basta] 2012-10-25 13:49:43 PDT
This is going to break every app in Marketplace (literally).

In order to allow installs, apps need to include `marketplace.mozilla.org` (and marketplace-dev.a.o, for -dev) in their "installs_allowed_from" fields. If we change the domain name, WebRT won't allow any of the existing apps that include `marketplace.mozilla.org` to be installed from the new domain name.

We will need to message every app developer to get them to modify their manifest file. All existing apps will need to be disabled and hidden form the marketplace. Apps need to be revalidated once they've been fixed, so we will either need to start polling manifests or provide a form for developers to re-submit through.

We cannot change the domain over until this has been done.
Comment 7 Chris More [:cmore] 2012-10-25 14:05:32 PDT
(In reply to Matt Basta [:basta] from comment #6)
> This is going to break every app in Marketplace (literally).
> 
> In order to allow installs, apps need to include `marketplace.mozilla.org`
> (and marketplace-dev.a.o, for -dev) in their "installs_allowed_from" fields.
> If we change the domain name, WebRT won't allow any of the existing apps
> that include `marketplace.mozilla.org` to be installed from the new domain
> name.
> 
> We will need to message every app developer to get them to modify their
> manifest file. All existing apps will need to be disabled and hidden form
> the marketplace. Apps need to be revalidated once they've been fixed, so we
> will either need to start polling manifests or provide a form for developers
> to re-submit through.
> 
> We cannot change the domain over until this has been done.

+1. I agree. This is also technically challenging and not a trivial change.
Comment 8 Jason Smith [:jsmith] 2012-10-25 14:35:36 PDT
(In reply to Chris More [:cmore] from comment #7)
> (In reply to Matt Basta [:basta] from comment #6)
> > This is going to break every app in Marketplace (literally).
> > 
> > In order to allow installs, apps need to include `marketplace.mozilla.org`
> > (and marketplace-dev.a.o, for -dev) in their "installs_allowed_from" fields.
> > If we change the domain name, WebRT won't allow any of the existing apps
> > that include `marketplace.mozilla.org` to be installed from the new domain
> > name.
> > 
> > We will need to message every app developer to get them to modify their
> > manifest file. All existing apps will need to be disabled and hidden form
> > the marketplace. Apps need to be revalidated once they've been fixed, so we
> > will either need to start polling manifests or provide a form for developers
> > to re-submit through.
> > 
> > We cannot change the domain over until this has been done.
> 
> +1. I agree. This is also technically challenging and not a trivial change.

Good catch. Didn't think of that implication initially. I entirely agree this warrants further discussion, cause that's a big risk towards app developers.

(In reply to Chris More [:cmore] from comment #4)
> (In reply to Jason Smith [:jsmith] from comment #1)
> > Sounds like something we should take care of before we ship - marketing has
> > been extremely critical about the URL being marketplace.firefox.com instead
> > of marketplace.mozilla.org. Although one could make the argument that we
> > could leave behind what we have and do a 301 to marketplace.firefox.com. But
> > it might be worth getting this done sooner rather than later.
> 
> Hey Jason.
> 
> When you say "marketing", who specifically are you referring to? This is the
> first I've heard about this.

I just got the memo through the apps go/no go discussion and various other apps threads that we have to advertise marketplace.firefox.com as the URL to go to, not marketplace.mozilla.org. I'm not best the person to get details on this or have a rationale why that's the case. I'll put needs info on the PM to go figure out how to resolve the contention issues brought up here.

Caitlin - Can you help out here?
Comment 9 Caitlin Galimidi [:c8o] 2012-10-25 14:57:04 PDT
Hey there y'all - Thanks so much for getting me in here.

What I'm hearing: 
1) changing the URLs is not a small ask, in fact, quite large and coordinated effort
2) there are many teams and areas impacted

Let's move forward to get an itemized list of impacts, so that we can properly communicate the magnitude of the change to the Marketing team making the request (Dave Slater). I can help manage the conflict if I have that info.

TECHNICAL IMPACTS so far:
- Marketplace (Clouser): run script to identify all instances of URL

- Apps (Clouser/Brewster): manifests = run script (?) to identify all instances of URL, identify developer contact info, communicate with developers , make the change (force the change?), test the apps, reapprove

- Performance (Connor): update performance mechanisms with new URL / manage change

- DevHub: (Wenzel) script to identify references which would need to change as well
- MDN: same (Swisher)
- Dev Docs: Same

- Bus Dev and Partner pages referencing Marketplace? (Elin, Piovesan, Horner, Livits)


STANDARDS / BRANDING IMPACT:
- Domain name strategy (JSlater, Swisher) vs Marketing Strategy (DSlater)

DSlater's team referenced a value study that was conducted explaining why we would get greater adoption and conversion with Firefox than Mozilla. He should be able to share that reference. 

Helpful?
What have I missed?
Comment 10 Jason Smith [:jsmith] 2012-10-25 15:05:01 PDT
(In reply to Caitlin Galimidi from comment #9)
> Hey there y'all - Thanks so much for getting me in here.
> 
> What I'm hearing: 
> 1) changing the URLs is not a small ask, in fact, quite large and
> coordinated effort
> 2) there are many teams and areas impacted
> 
> Let's move forward to get an itemized list of impacts, so that we can
> properly communicate the magnitude of the change to the Marketing team
> making the request (Dave Slater). I can help manage the conflict if I have
> that info.
> 
> TECHNICAL IMPACTS so far:
> - Marketplace (Clouser): run script to identify all instances of URL
> 
> - Apps (Clouser/Brewster): manifests = run script (?) to identify all
> instances of URL, identify developer contact info, communicate with
> developers , make the change (force the change?), test the apps, reapprove
> 
> - Performance (Connor): update performance mechanisms with new URL / manage
> change
> 
> - DevHub: (Wenzel) script to identify references which would need to change
> as well
> - MDN: same (Swisher)
> - Dev Docs: Same
> 
> - Bus Dev and Partner pages referencing Marketplace? (Elin, Piovesan,
> Horner, Livits)
> 
> 
> STANDARDS / BRANDING IMPACT:
> - Domain name strategy (JSlater, Swisher) vs Marketing Strategy (DSlater)
> 
> DSlater's team referenced a value study that was conducted explaining why we
> would get greater adoption and conversion with Firefox than Mozilla. He
> should be able to share that reference. 
> 
> Helpful?
> What have I missed?

The only thing I see missed on the apps area:

- Apps (Clouser/Brewster): manifests = run script (?) to identify all instances of URL, identify developer contact info, communicate with developers , make the change (force the change?), test the apps, reapprove

A script won't help here. Remember - every web app on marketplace has to specify marketplace.mozilla.org in the installs_allowed_from field. In short, I fully expect every single web app to have this in the installs_allowed_from field. I don't expect almost any web apps to specify marketplace.firefox.com right now.

This is a high risk change as Matt pointed out - I would rather not fight an evangelism war for something that we have control over. I'd suggest backing up and evaluating tradeoffs again on whether marketplace.firefox.com is still a viable solution to go to given the known risks.
Comment 11 Chris More [:cmore] 2012-10-25 15:33:16 PDT
All: Please hold from making any changes or plans. Stormy Peters is talking to Product Marketing about this request. We'll get this bug updated soon on the outcome of these discussions.

Another idea is that we could use use this a vanity URL that 301 redirects to marketplace.mozilla.org with a query string that could be used to track conversions.
Comment 12 Gervase Markham [:gerv] 2012-10-26 03:02:09 PDT
Aside from the technical question of whether we can even change this (which could be fixed by the approach suggested in comment #11), there is the question of what message we send by using a particular URL.

Is there anywhere I can read a write-up of the rationale why we want to use the firefox.com domain name rather than the mozilla.org one for the Marketplace? In particular, analysis of the effect this has on our message that web apps are for all standards-compliant browsers, and "the web is the platform", not Firefox.

"DSlater's team referenced a value study that was conducted explaining why we would get greater adoption and conversion with Firefox than Mozilla. He should be able to share that reference." 

I'd love to see that study; but by itself, that would not be a clinching argument IMO.

Gerv
Comment 13 Andrew Williamson [:eviljeff] 2012-10-26 08:05:01 PDT
(In reply to Matt Basta [:basta] from comment #6)
> This is going to break every app in Marketplace (literally).
> 
> In order to allow installs, apps need to include `marketplace.mozilla.org`
> (and marketplace-dev.a.o, for -dev) in their "installs_allowed_from" fields.
> If we change the domain name, WebRT won't allow any of the existing apps
> that include `marketplace.mozilla.org` to be installed from the new domain
> name.
> 
> We will need to message every app developer to get them to modify their
> manifest file. All existing apps will need to be disabled and hidden form
> the marketplace. Apps need to be revalidated once they've been fixed, so we
> will either need to start polling manifests or provide a form for developers
> to re-submit through.
> 
> We cannot change the domain over until this has been done.

I logged bug 805473 on the back of the mention in bug 799563.  Its not an insurmountable problem - we'll just need to ask developers to add marketplace.firefox.com as well as marketplace.mozilla.org and as long as we give them enough notice it should be doable.  Manifests won't need to be resubmitted via the site and once bug 802561 is implemented we'll be able to run a forced revalidation and scoop up anyone who didn't comply with the email in the re-review queue.
Comment 14 Jason Smith [:jsmith] 2012-10-26 08:30:23 PDT
(In reply to Andrew Williamson [:eviljeff] from comment #13)
> (In reply to Matt Basta [:basta] from comment #6)
> > This is going to break every app in Marketplace (literally).
> > 
> > In order to allow installs, apps need to include `marketplace.mozilla.org`
> > (and marketplace-dev.a.o, for -dev) in their "installs_allowed_from" fields.
> > If we change the domain name, WebRT won't allow any of the existing apps
> > that include `marketplace.mozilla.org` to be installed from the new domain
> > name.
> > 
> > We will need to message every app developer to get them to modify their
> > manifest file. All existing apps will need to be disabled and hidden form
> > the marketplace. Apps need to be revalidated once they've been fixed, so we
> > will either need to start polling manifests or provide a form for developers
> > to re-submit through.
> > 
> > We cannot change the domain over until this has been done.
> 
> I logged bug 805473 on the back of the mention in bug 799563.  Its not an
> insurmountable problem - we'll just need to ask developers to add
> marketplace.firefox.com as well as marketplace.mozilla.org and as long as we
> give them enough notice it should be doable.  Manifests won't need to be
> resubmitted via the site and once bug 802561 is implemented we'll be able to
> run a forced revalidation and scoop up anyone who didn't comply with the
> email in the re-review queue.

Andrew - Please hold off until cmore provides an update. Then, we'll figure out where to go from there.
Comment 15 Andrew Williamson [:eviljeff] 2012-10-26 08:34:13 PDT
(In reply to Jason Smith [:jsmith] from comment #10)
> The only thing I see missed on the apps area:
> 
> - Apps (Clouser/Brewster): manifests = run script (?) to identify all
> instances of URL, identify developer contact info, communicate with
> developers , make the change (force the change?), test the apps, reapprove
> 
> A script won't help here. Remember - every web app on marketplace has to
> specify marketplace.mozilla.org in the installs_allowed_from field. In
> short, I fully expect every single web app to have this in the
> installs_allowed_from field. I don't expect almost any web apps to specify
> marketplace.firefox.com right now.

I don't have any stats but installs_allowed_from is optional and I'm not sure what percentage of apps actually include it (none of the 3 apps I picked at random out of the queue atm had it, for example).  It'll still be a large impact (I imagine) but not 100%.

We can't force any change (each developer will need to change their manifest) but we shouldn't need to actually re-test and re-approve apps if the validator does its job.  For the developers that don't inadvertently break the manifest at least.
Comment 16 Jason Smith [:jsmith] 2012-10-26 08:49:27 PDT
(In reply to Andrew Williamson [:eviljeff] from comment #15)
> (In reply to Jason Smith [:jsmith] from comment #10)
> > The only thing I see missed on the apps area:
> > 
> > - Apps (Clouser/Brewster): manifests = run script (?) to identify all
> > instances of URL, identify developer contact info, communicate with
> > developers , make the change (force the change?), test the apps, reapprove
> > 
> > A script won't help here. Remember - every web app on marketplace has to
> > specify marketplace.mozilla.org in the installs_allowed_from field. In
> > short, I fully expect every single web app to have this in the
> > installs_allowed_from field. I don't expect almost any web apps to specify
> > marketplace.firefox.com right now.
> 
> I don't have any stats but installs_allowed_from is optional and I'm not
> sure what percentage of apps actually include it (none of the 3 apps I
> picked at random out of the queue atm had it, for example).  It'll still be
> a large impact (I imagine) but not 100%.
> 
> We can't force any change (each developer will need to change their
> manifest) but we shouldn't need to actually re-test and re-approve apps if
> the validator does its job.  For the developers that don't inadvertently
> break the manifest at least.

Ah, my bad, you are right. Somehow my brain confused the fallback behavior of installs_allowed_from. I'll still dig into the redirects issue though with the installs_allowed_from field, however.
Comment 17 David Slater 2012-10-26 10:17:29 PDT
Your marketing rationale. This decision was made between myself and Pete Scanlon, our head of Brand in the context of the Apps Workweek in late July.

In summary, there will be tremendous investment in the Firefox brand; nominal in the Mozilla brand which will be targeted at industry (and in terms of consumers, our ultimate target, Firefox is what they already know and trust). It is in the Marketplace's long-term best interest to be as tightly aligned in that investment as possible.

We and our partners will be investing upwards of $100M into promoting the Firefox brand over the next few years, which has up to 98% consumer brand awareness in some studies, rather than Mozilla, which trails considerably in terms of consumer brand awareness (even among Firefox users). Millions of phones will have the word "Firefox" physically printed on them and a start screen that says "Firefox", wireless phone carriers around the world will have "Firefox" in their 10's of thousands of front windows as early as late next year and into 2014. The more Marketplace is associated with Firefox, the better the Marketplace will do.

Over the next few years we are transitioning "Firefox" from meaning "desktop browser" into our brand umbrella for a range of consumer products: Marketplace, OS, browsers, and anything else we create for mass consumers in the future. As for the notion "we'll distribute apps that run in other browsers", our goal is to extend the meaning of "Firefox", not to limit it to mean "desktop browser."

Furthermore, Marketplace is not merely a website supporting products like other Mozilla.org properties, it's a product in itself. It's also in service to the Firefox OS brand family rather than a top level Mozilla brand, which is why it's called "Firefox Marketplace" and its URL structure follows a Firefox.com naming convention rather than a Mozilla.org. Lastly, associating the URL with our marquee brand the world already knows and will continue to know will help the product succeed by avoiding confusion with both consumers and press.

Changing this now may be technically difficult, but easier to do now with 100 apps in the Marketplace than when there are hundreds of thousands.

Everything we can do to associate Marketplace with Firefox will help the Marketplace succeed, as that's the brand that will get the lion's share of the attention & investment going forward.
Comment 18 Jason Smith [:jsmith] 2012-10-26 10:26:29 PDT
David - Thank you very much for providing the thorough rationale. I think we've got an understanding now on the why aspect, and I believe your rationale makes sense.

I also spoke with Fabrice about rules with redirects with the installs_allowed_from field - the final place we redirect to will be represented as the "true origin" for hosted web apps. It's also the place we're trying to evangelize as the central point to reference. Let's move forward with the original plan Caitlin has specified out.
Comment 19 Rubén Martín [:Nukeador] 2012-10-26 10:54:11 PDT
Hi all,

Shouldn't the discussion about the change be separated from the technical changes this bug is about?

Bugzilla is not intended to be a discussion forum, there are 2 topics opened at marketing list about this, let's more there :)

https://groups.google.com/forum/?fromgroups#!forum/mozilla.marketing
Comment 20 Gervase Markham [:gerv] 2012-10-29 06:49:06 PDT
One note on install_allowed_from: setting this value should be explicitly _dis_couraged unless the app is a paid app. See:
http://www.mail-archive.com/dev-webapps@lists.mozilla.org/msg00014.html
This is because it's a bar to openness and to the flourishing of multiple app stores.

So if we go around asking people to update this value, we must be sure to make this clear.

Gerv
Comment 21 Jason Smith [:jsmith] 2012-10-29 08:51:38 PDT
(In reply to Gervase Markham [:gerv] from comment #20)
> One note on install_allowed_from: setting this value should be explicitly
> _dis_couraged unless the app is a paid app. See:
> http://www.mail-archive.com/dev-webapps@lists.mozilla.org/msg00014.html
> This is because it's a bar to openness and to the flourishing of multiple
> app stores.
> 
> So if we go around asking people to update this value, we must be sure to
> make this clear.
> 
> Gerv

Good point. I don't think our dev docs calls this out though, but it should. I'll file a separate bug for updating our dev docs to indicate this.
Comment 22 Rick Fant 2012-10-29 08:55:10 PDT
Please note - that the old URL's should no go away.  They old URL's should be redirected to the new URL providing compatibility for the foreseeable future and not breaking any existing sites.
Comment 23 Mike Connor [:mconnor] 2012-10-29 11:59:28 PDT
retriage: If we're doing this, we need to do this ASAP. -> P1
Comment 24 Matt Basta [:basta] 2012-10-31 11:47:40 PDT
As a note: if/when this happens, we need to make sure we update our reCAPTCHA keys or none of our captchas will work.
Comment 25 Wil Clouser [:clouserw] 2012-10-31 13:22:16 PDT
(In reply to Matt Basta [:basta] from comment #24)
> As a note: if/when this happens, we need to make sure we update our
> reCAPTCHA keys or none of our captchas will work.

That's a marketplace bug, not this bug.
Comment 26 Wil Clouser [:clouserw] 2012-11-06 09:32:25 PST
Decision has been made, URL change is happening.  I'll coordinate a timeline with IT in bug 799563.
Comment 27 Chris More [:cmore] 2012-11-06 10:54:42 PST
(In reply to Wil Clouser [:clouserw] from comment #26)
> Decision has been made, URL change is happening.  I'll coordinate a timeline
> with IT in bug 799563.

Wil: You can an open action item to see if apps will install via a redirect or if we need to coordinate the URL change so that there is a specific cut off date. What did you find out with using a redirect in the short-term and then cutting over later?
Comment 28 Jason Smith [:jsmith] 2012-11-06 11:16:06 PST
(In reply to Chris More [:cmore] from comment #27)
> (In reply to Wil Clouser [:clouserw] from comment #26)
> > Decision has been made, URL change is happening.  I'll coordinate a timeline
> > with IT in bug 799563.
> 
> Wil: You can an open action item to see if apps will install via a redirect
> or if we need to coordinate the URL change so that there is a specific cut
> off date. What did you find out with using a redirect in the short-term and
> then cutting over later?

We can't install apps via a redirect per a thread with Jonas, Wil, and Mike.
Comment 29 Wil Clouser [:clouserw] 2012-11-06 11:17:34 PST
Jonas says redirects will fail, we'll need to change the .manifest files.  Bug 805473 is going to notify developers about that change, bug 799563 is the current blocker for figuring out a timeline.  

Rough steps:
1) IT needs to buy a new EV cert and get the domain set up
2) We notify developers giving ~1 week notice
3) We flip the domains ~1 week later

The above ignores the b2g changes because I'm not sure what their schedule is.
Comment 30 Wil Clouser [:clouserw] 2012-11-09 10:48:16 PST
We are a go on this for Nov 15th.  I'm going to email the affected app developers shortly.  If there is a reason not to do this on the 15th let me know now.
Comment 31 Alex Keybl [:akeybl] 2012-11-12 10:43:31 PST
Milestoning for C2 (deadline of 12/10), as this meets the criteria of "remaining P1 bugs not already milestoned for C1".
Comment 32 Jason Smith [:jsmith] 2012-11-12 23:27:55 PST
Cvan has a patch out already apparently:

https://github.com/mozilla-b2g/gaia/pull/6369

Someone needs to review this.
Comment 33 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-11-13 10:25:16 PST
(In reply to Jason Smith [:jsmith] from comment #32)
> Cvan has a patch out already apparently:
> 
> https://github.com/mozilla-b2g/gaia/pull/6369
> 
> Someone needs to review this.

I add a comment in Github asking if it can land before the 15th without hurts? This is a bit unclear to me :)
Comment 34 Vivien Nicolas (:vingtetun) (:21) - (NOT reading bugmails, needinfo? please) 2012-11-19 08:04:41 PST
https://github.com/mozilla-b2g/gaia/commit/251e5bae5f8a687ad6e9d26d4780c79a4547eab0
Comment 35 amiller 2013-01-04 10:41:33 PST
Device: Unagi 
Build ID: 20130103070201
marketplace.firefox.com is the URL for Marketplace at this time.
Comment 36 Chris More [:cmore] 2013-01-04 15:44:03 PST
SUMO should update the URL here: https://support.mozilla.org/en-US/kb/how-access-firefox-marketplace

Note You need to log in before you can comment on or make changes to this bug.